package gregapi;

import static gregapi.data.CS.*;
import gregapi.api.Abstract_Mod;
import gregapi.api.Abstract_Proxy;
import gregapi.block.IBlockOnWalkOver;
import gregapi.block.IBlockPlacable;
import gregapi.block.IBlockToolable;
import gregapi.block.metatype.BlockBasePlanks;
import gregapi.block.misc.BlockBaseBale;
import gregapi.block.multitileentity.MultiTileEntityItemInternal;
import gregapi.block.multitileentity.MultiTileEntityRegistry;
import gregapi.block.tree.BlockBaseBeam;
import gregapi.block.tree.BlockBaseLog;
import gregapi.block.tree.BlockBaseSapling;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.HashSetNoNulls;
import gregapi.code.ItemStackContainer;
import gregapi.data.CS.BlocksGT;
import gregapi.data.CS.BooksGT;
import gregapi.data.CS.FoodsGT;
import gregapi.data.CS.ModIDs;
import gregapi.data.CS.PotionsGT;
import gregapi.data.CS.SFX;
import gregapi.data.CS.ToolsGT;
import gregapi.data.*;
import gregapi.item.IItemNoGTOverride;
import gregapi.item.IItemProjectile;
import gregapi.item.IItemProjectile.EntityProjectile;
import gregapi.item.multiitem.MultiItemRandom;
import gregapi.item.multiitem.MultiItemTool;
import gregapi.network.packets.PacketConfig;
import gregapi.network.packets.PacketDeathPoint;
import gregapi.network.packets.PacketPrefix;
import gregapi.oredict.IOreDictListenerItem;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.oredict.OreDictPrefix;
import gregapi.player.EntityFoodTracker;
import gregapi.tileentity.*;
import gregapi.tileentity.inventories.ITileEntityBookShelf;
import gregapi.util.OM;
import gregapi.util.ST;
import gregapi.util.UT;
import gregapi.util.WD;
import gregapi.worldgen.GT6WorldGenerator;

import java.io.File;
import java.util.ConcurrentModificationException;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

import micdoodle8.mods.galacticraft.api.event.wgen.GCCoreEventPopulate;
import net.minecraft.block.Block;
import net.minecraft.block.BlockJukebox.TileEntityJukebox;
import net.minecraft.block.material.Material;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.item.EntityXPOrb;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.potion.PotionEffect;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.WorldSettings;
import net.minecraft.world.chunk.Chunk;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.ForgeEventFactory;
import net.minecraftforge.event.entity.EntityEvent.EntityConstructing;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import net.minecraftforge.event.entity.item.ItemExpireEvent;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.living.LivingEvent.LivingUpdateEvent;
import net.minecraftforge.event.entity.living.LivingSpawnEvent;
import net.minecraftforge.event.entity.player.*;
import net.minecraftforge.event.world.BlockEvent;
import net.minecraftforge.event.world.ChunkWatchEvent;
import net.minecraftforge.event.world.WorldEvent;
import net.minecraftforge.fluids.IFluidContainerItem;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.IFuelHandler;
import cpw.mods.fml.common.IWorldGenerator;
import cpw.mods.fml.common.Optional;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.event.FMLServerStoppedEvent;
import cpw.mods.fml.common.eventhandler.Event.Result;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.TickEvent.Phase;
import cpw.mods.fml.common.gameevent.TickEvent.PlayerTickEvent;
import cpw.mods.fml.common.gameevent.TickEvent.ServerTickEvent;
import cpw.mods.fml.common.gameevent.TickEvent.WorldTickEvent;
import cpw.mods.fml.common.network.IGuiHandler;
import cpw.mods.fml.common.registry.GameRegistry;

/**
 * @author Gregorius Techneticies
 */
public abstract class GT_API_Proxy extends Abstract_Proxy implements IGuiHandler, IFuelHandler, IWorldGenerator {
	private World mUniverse = null;
	
	public GT_API_Proxy() {
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, Integer.MAX_VALUE);
		MinecraftForge.EVENT_BUS.register(this);
		FMLCommonHandler.instance().bus().register(this);
	}
	
	public EntityPlayer getThePlayer() {
		return null;
	}
	
	public boolean sendUseItemPacket(EntityPlayer aPlayer, World aWorld, ItemStack aStack) {
		return F;
	}
	
	@Override
	public Object getServerGuiElement(int aGUIID, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ) {
		TileEntity tTileEntity = WD.te(aWorld, aX, aY, aZ, T);
		return tTileEntity instanceof ITileEntityGUI ? ((ITileEntityGUI)tTileEntity).getGUIServer(aGUIID, aPlayer) : null;
	}
	
	@Override
	public Object getClientGuiElement(int aGUIID, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ) {
		TileEntity tTileEntity = WD.te(aWorld, aX, aY, aZ, T);
		return tTileEntity instanceof ITileEntityGUI ? ((ITileEntityGUI)tTileEntity).getGUIClient(aGUIID, aPlayer) : null;
	}
	
	@Override
	public void onProxyBeforeServerStarting(Abstract_Mod aMod, FMLServerStartingEvent aEvent) {
		SERVER_TIME = 0;
	}
	
	@Override
	public void onProxyAfterServerStopped(Abstract_Mod aMod, FMLServerStoppedEvent aEvent) {
		if (mSaveLocation != null) {
			new File(mSaveLocation, "gregtech").mkdirs();
			MultiTileEntityRegistry.onServerSave(mSaveLocation);
		}
		mUniverse = null;
		mSaveLocation = null;
	}
	
	public File getSaveDirectory() {
		if (mUniverse != null) mSaveLocation = mUniverse.getSaveHandler().getWorldDirectory();
		return mSaveLocation;
	}
	
	public File mSaveLocation = null;
	
	@SubscribeEvent
	public void onWorldLoad(WorldEvent.Load aEvent) {
		if (mUniverse == null) {
			mUniverse = aEvent.world;
			getSaveDirectory();
			if (mSaveLocation != null) {
				new File(mSaveLocation, "gregtech").mkdirs();
				MultiTileEntityRegistry.onServerLoad(mSaveLocation);
			}
		}
	}
	
	public  static final List<ITileEntityServerTickPre	> SERVER_TICK_PRE					= new ArrayListNoNulls<ITileEntityServerTickPre>(), SERVER_TICK_PR2 = new ArrayListNoNulls<ITileEntityServerTickPre>();
	public  static final List<ITileEntityServerTickPost	> SERVER_TICK_POST					= new ArrayListNoNulls<ITileEntityServerTickPost>(), SERVER_TICK_PO2T = new ArrayListNoNulls<ITileEntityServerTickPost>();
	public  static List<ITileEntityScheduledUpdate		> SCHEDULED_TILEENTITY_UPDATES		= new ArrayListNoNulls<ITileEntityScheduledUpdate>();
	private static List<ITileEntityScheduledUpdate		> SCHEDULED_TILEENTITY_UPDATES_2	= new ArrayListNoNulls<ITileEntityScheduledUpdate>();
	
	@SubscribeEvent
	public void onServerTick(ServerTickEvent aEvent) {
		if (aEvent.side.isServer()) {
			if (aEvent.phase == Phase.START) {
				SERVER_TIME++;
				
				for (int i = 0; i < SERVER_TICK_PRE.size(); i++) {
					ITileEntityServerTickPre tTileEntity = SERVER_TICK_PRE.get(i);
					if (tTileEntity.isDead()) {
						SERVER_TICK_PRE.remove(i--);
						tTileEntity.onUnregisterPre();
					} else {
						tTileEntity.onServerTickPre();
					}
				}
				for (int i = 0; i < SERVER_TICK_PR2.size(); i++) {
					ITileEntityServerTickPre tTileEntity = SERVER_TICK_PR2.get(i);
					if (tTileEntity.isDead()) {
						SERVER_TICK_PR2.remove(i--);
						tTileEntity.onUnregisterPre();
					} else {
						tTileEntity.onServerTickPre();
					}
				}
				
				if (SERVER_TIME > 10) {
					for (ITileEntityScheduledUpdate tTileEntity : SCHEDULED_TILEENTITY_UPDATES_2) if (!tTileEntity.isDead()) tTileEntity.onScheduledUpdate();
					SCHEDULED_TILEENTITY_UPDATES_2.clear();
					List<ITileEntityScheduledUpdate> tList = SCHEDULED_TILEENTITY_UPDATES_2;
					SCHEDULED_TILEENTITY_UPDATES_2 = SCHEDULED_TILEENTITY_UPDATES;
					SCHEDULED_TILEENTITY_UPDATES = tList;
					
					while (!mNewPlayers.isEmpty()) {
						EntityPlayerMP tPlayer = mNewPlayers.remove(0);
						NW_API.sendToPlayer(new PacketConfig(), tPlayer);
						for (OreDictPrefix tPrefix : OreDictPrefix.VALUES) if (!tPrefix.contains(TD.Prefix.PREFIX_UNUSED)) NW_API.sendToPlayer(new PacketPrefix(tPrefix), tPlayer);
					}
				}
			}
			
			if (aEvent.phase == Phase.END) {
				for (int i = 0; i < SERVER_TICK_POST.size(); i++) {
					ITileEntityServerTickPost tTileEntity = SERVER_TICK_POST.get(i);
					if (tTileEntity.isDead()) {
						SERVER_TICK_POST.remove(i--);
						tTileEntity.onUnregisterPost();
					} else {
						tTileEntity.onServerTickPost();
					}
				}
				for (int i = 0; i < SERVER_TICK_PO2T.size(); i++) {
					ITileEntityServerTickPost tTileEntity = SERVER_TICK_PO2T.get(i);
					if (tTileEntity.isDead()) {
						SERVER_TICK_PO2T.remove(i--);
						tTileEntity.onUnregisterPost();
					} else {
						tTileEntity.onServerTickPost();
					}
				}
				EntityFoodTracker.tick();
			}
		}
	}
	
	@SubscribeEvent
	public void onLivingUpdate(LivingUpdateEvent aEvent) {
		if (aEvent.entityLiving.onGround) {
			int tX = MathHelper.floor_double(aEvent.entityLiving.posX), tY = MathHelper.floor_double(aEvent.entityLiving.boundingBox.minY-0.001F), tZ = MathHelper.floor_double(aEvent.entityLiving.posZ);
			Block tBlock = aEvent.entityLiving.worldObj.getBlock(tX, tY, tZ);
			if (tBlock instanceof IBlockOnWalkOver) ((IBlockOnWalkOver)tBlock).onWalkOver(aEvent.entityLiving, aEvent.entityLiving.worldObj, tX, tY, tZ);
		}
	}
	
	@SubscribeEvent
	public void onWorldTick(WorldTickEvent aEvent) {
		if (aEvent.side.isServer() && aEvent.phase == Phase.END) {
			ArrayListNoNulls<EntityXPOrb> tOrbs = (XP_ORB_COMBINING && SERVER_TIME % 40 == 31 ? new ArrayListNoNulls<EntityXPOrb>(128) : null);
			
			for (int i = 0; i < aEvent.world.loadedEntityList.size(); i++) {
				Entity aEntity = (Entity)aEvent.world.loadedEntityList.get(i);
				if (aEntity == null || aEntity.isDead) continue;
				if (aEntity instanceof EntityXPOrb) {
					if (tOrbs != null) tOrbs.add((EntityXPOrb)aEntity);
				} else if (aEntity instanceof EntityItem) {
					ItemStack aStack = ((EntityItem)aEntity).getEntityItem();
					if (ST.valid(aStack)) {
						ItemStack rStack = ST.copy(aStack);
						
						boolean tBreak = F;
						OreDictItemData aData = OM.anydata_(rStack);
						if (aData != null) {
							if (aData.mPrefix != null) for (IOreDictListenerItem tListener : aData.mPrefix.mListenersItem) {
								rStack = tListener.onTickWorld(aData.mPrefix, aData.mMaterial.mMaterial, rStack, (EntityItem)aEntity);
								if (!ST.equal(rStack, aStack) || rStack.stackSize != aStack.stackSize) {tBreak = T; break;}
							}
							if (!tBreak && aData.mMaterial != null) for (OreDictMaterialStack tMaterial : aData.getAllMaterialStacks()) {
								if (tBreak) break;
								for (IOreDictListenerItem tListener : tMaterial.mMaterial.mListenersItem) {
									rStack = tListener.onTickWorld(aData.mPrefix, tMaterial.mMaterial, rStack, (EntityItem)aEntity);
									if (!ST.equal(rStack, aStack) || rStack.stackSize != aStack.stackSize) {tBreak = T; break;}
								}
							}
							if (rStack == null || rStack.stackSize <= 0) {
								((EntityItem)aEntity).setEntityItemStack(NI);
								((EntityItem)aEntity).setDead();
							} else {
								((EntityItem)aEntity).setEntityItemStack(rStack);
							}
						}
					}
				} else if (aEntity instanceof EntityLivingBase) {
				   	if (ENTITY_CRAMMING > 0 && SERVER_TIME % 50 == 0 && !(aEntity instanceof EntityPlayer) && ((EntityLivingBase)aEntity).canBePushed() && ((EntityLivingBase)aEntity).getHealth() > 0) {
			 			List tList = aEntity.worldObj.getEntitiesWithinAABBExcludingEntity(aEntity, aEntity.boundingBox.expand(0.2, 0.0, 0.2));
			 			Class tClass = aEntity.getClass();
			 			int aEntityCount = 1;
			 			if (tList != null) for (int j = 0; j < tList.size(); j++) if (tList.get(j) != null && tList.get(j).getClass() == tClass) aEntityCount++;
			 			if (aEntityCount > ENTITY_CRAMMING) aEntity.attackEntityFrom(DamageSource.inWall, aEntityCount - ENTITY_CRAMMING);
				 	}
				}
			}
			
			if (tOrbs != null && tOrbs.size() > 32) for (EntityXPOrb aOrb : tOrbs) {
				if (aOrb.xpValue >= Short.MAX_VALUE) continue;
				if (aOrb.xpValue <= 0) {aOrb.xpValue = 0; aOrb.setDead(); continue;}
				for (EntityXPOrb tOrb : tOrbs) if (aOrb != tOrb && !tOrb.isDead && tOrb.xpValue > 0 && tOrb.xpValue < Short.MAX_VALUE && aOrb.getDistanceSqToEntity(tOrb) <= 3) {
					aOrb.xpOrbAge = Math.min(aOrb.xpOrbAge, tOrb.xpOrbAge);
					if (aOrb.xpValue +  tOrb.xpValue > Short.MAX_VALUE) {
						tOrb.xpValue -= (Short.MAX_VALUE - aOrb.xpValue);
						aOrb.xpValue  =  Short.MAX_VALUE;
						break;
					}
					aOrb.xpValue += tOrb.xpValue;
					tOrb.xpValue  = 0;
					tOrb.setDead();
					break;
				}
			}
			
			if (SERVER_TIME % 20 == 1) {
				for (int i = 0; i < aEvent.world.loadedTileEntityList.size(); i++) {
					TileEntity aTileEntity = (TileEntity)aEvent.world.loadedTileEntityList.get(i);
					if (aTileEntity instanceof ITileEntityNeedsSaving) aTileEntity.getWorldObj().getChunkFromBlockCoords(aTileEntity.xCoord, aTileEntity.zCoord).setChunkModified();
				}
			}
		}
	}
	
	@SubscribeEvent
	public void onPlayerItemPickupEvent(cpw.mods.fml.common.gameevent.PlayerEvent.ItemPickupEvent aEvent) {
		UT.Inventories.checkAchievements(aEvent.player, aEvent.pickedUp.getEntityItem());
	}
	
	private int BEAR_INVENTORY_COOL_DOWN = 5;
	
	@SubscribeEvent
	public void onPlayerTickEventServer(PlayerTickEvent aEvent) {
		if (!aEvent.player.isDead && aEvent.phase == Phase.END && aEvent.side.isServer()) {
			if (SURVIVAL_INTO_ADVENTURE_MODE && aEvent.player.ticksExisted%200==0 && aEvent.player.capabilities.allowEdit && !UT.Entities.isCreative(aEvent.player)) {
				aEvent.player.setGameType(WorldSettings.GameType.ADVENTURE);
				aEvent.player.capabilities.allowEdit = F;
				if (ADVENTURE_MODE_KIT) {
					if (MD.GT.mLoaded) {
						UT.Entities.chat(aEvent.player, "Thanks for choosing our Adventure Mode Starter Kit.");
						UT.Entities.chat(aEvent.player, "We know you could have chosen any other Kit.");
						UT.Entities.chat(aEvent.player, "And are proud that you chose ours as the best.");
						ST.drop(aEvent.player, ST.make(Items.flint, 12, 0));
						ST.drop(aEvent.player, ST.make(Items.stick,  8, 0));
						ST.drop(aEvent.player, IL.Grass_Dry.get(8));
						ST.drop(aEvent.player, IL.Bottle_Purple_Drink.get(6));
						switch (RANDOM.nextInt(4)) {
						case 0: ST.drop(aEvent.player, IL.Food_Large_Sandwich_Veggie.get(1)); break;
						case 1: ST.drop(aEvent.player, IL.Food_Large_Sandwich_Cheese.get(1)); break;
						case 2: ST.drop(aEvent.player, IL.Food_Large_Sandwich_Steak .get(1)); break;
						case 3: ST.drop(aEvent.player, IL.Food_Large_Sandwich_Bacon .get(1)); break;
						}
					} else {
						UT.Entities.chat(aEvent.player, "It's dangerous to go alone! Take this.");
						ST.drop(aEvent.player, ST.make(Items.stone_axe, 1, 0));
					}
				}
			}
			boolean tHungerEffect = (HUNGER_BY_INVENTORY_WEIGHT && aEvent.player.ticksExisted % 2400 == 1200);
			if (aEvent.player.ticksExisted % 120 == 0) {
				ItemStack tStack;
				int tCount = 64, tEmptySlots = 36;
				for (int i = 0; i < 36; i++) {
					if (ST.valid(tStack = aEvent.player.inventory.getStackInSlot(i))) {
						tEmptySlots--;
						if (!UT.Entities.isInvincible(aEvent.player)) {
							UT.Entities.applyRadioactivity(aEvent.player, UT.Entities.getRadioactivityLevel(tStack), tStack.stackSize);
							float tHeat = UT.Entities.getHeatDamageFromItem(tStack);
							if (tHeat != 0.0F) if (tHeat > 0) UT.Entities.applyHeatDamage(aEvent.player, tHeat); else UT.Entities.applyFrostDamage(aEvent.player, -tHeat);
						}
						if (tHungerEffect) tCount+=(tStack.stackSize * 64) / Math.max(1, tStack.getMaxStackSize());
						if (INVENTORY_UNIFICATION) OM.set_(tStack);
						ST.update(tStack);
					}
				}
				
				// This Code is to tell Bear and all the people around him that he should clean up his always cluttered Inventory.
				if ("Bear989Sr".equalsIgnoreCase(aEvent.player.getCommandSenderName())) {
					if (--BEAR_INVENTORY_COOL_DOWN < 0 && tEmptySlots < 4) {
						BEAR_INVENTORY_COOL_DOWN = 100;
						UT.Sounds.send(SFX.MC_HMM, aEvent.player);
						for (int i = 0; i < aEvent.player.worldObj.playerEntities.size(); i++) {
							EntityPlayer tPlayer = (EntityPlayer)aEvent.player.worldObj.playerEntities.get(i);
							if (tPlayer == null) continue;
							if ("Bear989Sr".equalsIgnoreCase(tPlayer.getCommandSenderName())) {
								switch(tEmptySlots) {
								case 0:	UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " You are full of shit, Sir!!!")); break;
								case 1:	UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Your Inventory is almost full, Sir!!")); break;
								case 2:	UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " You should clean up your Inventory, Mr. Bear!")); break;
								case 3:	UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Mr. Bear, your Inventory starts to get full.")); break;
								}
							} else if ("Bear989jr".equalsIgnoreCase(tPlayer.getCommandSenderName())) {
				  				UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Would you please not tell your dad to clean his fucking Inventory again?"));
				  			} else if ("andyafw92".equalsIgnoreCase(tPlayer.getCommandSenderName())) {
				  				UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Mr. Bears Inventory is nasty again, would you please remind him to clean it?"));
				  			} else if ("CrazyJ1984".equalsIgnoreCase(tPlayer.getCommandSenderName())) {
				  				UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Mr. Bear seems to be a Messy again, maybe kill him to empty up his Inventory a little."));
				  			} else if ("Ilirith".equalsIgnoreCase(tPlayer.getCommandSenderName())) {
				  				UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Could you tell Mr. Bear very gently, that his Inventory is a fucking mess again?"));
				  			} else if ("Shadowkn1ght18".equalsIgnoreCase(tPlayer.getCommandSenderName())) {
			  					UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " Here is your special Message to make you tell Mr. Bear to clean his Inventory."));
			  				} else {
				  				UT.Entities.chat(tPlayer, new ChatComponentText(CHAT_GREG + " There is this fella called Bear989Sr, his Inventory being a mess. Would you please remind him to clean it?"));
				  			}
						}
					}
		  		}
				
				for (int i = 0; i < 4; i++) if ((tStack = aEvent.player.inventory.armorInventory[i]) != null) {
					if (!UT.Entities.isInvincible(aEvent.player)) {
						UT.Entities.applyRadioactivity(aEvent.player, UT.Entities.getRadioactivityLevel(tStack), tStack.stackSize);
						float tHeat = UT.Entities.getHeatDamageFromItem(tStack);
						if (tHeat != 0.0F) if (tHeat > 0) UT.Entities.applyHeatDamage(aEvent.player, tHeat); else UT.Entities.applyFrostDamage(aEvent.player, -tHeat);
					}
					if (tHungerEffect) tCount+=256;
				}
				if (tHungerEffect) aEvent.player.addExhaustion(Math.max(1.0F, tCount/666F));
			}
		}
	}
	
	@SubscribeEvent
	public void onChunkWatchEvent(ChunkWatchEvent.Watch aEvent) {
		Chunk tChunk = aEvent.player.worldObj.getChunkFromChunkCoords(aEvent.chunk.chunkXPos, aEvent.chunk.chunkZPos);
		if (tChunk != null && tChunk.isTerrainPopulated) {
			byte tIterations = 8;
			HashSetNoNulls<Object> tSet = new HashSetNoNulls<Object>();
			while (tIterations-->0) try {
				for (Object tTileEntity : tChunk.chunkTileEntityMap.values()) if (tTileEntity instanceof ITileEntitySynchronising) if (tSet.add(tTileEntity)) ((ITileEntitySynchronising)tTileEntity).sendUpdateToPlayer(aEvent.player);
				tIterations = 0;
			} catch(ConcurrentModificationException e) {
				if (tIterations <= 0) ERR.println("Failed to Iterate 8 times. Giving up on sending Data to Client!");
			}
		}
	}
	
	@SubscribeEvent
	public void onPlayerDestroyItem(PlayerDestroyItemEvent aEvent) {
		if (!UT.Entities.isPlayer(aEvent.entityPlayer) || aEvent.original == null || UT.Entities.hasInfiniteItems(aEvent.entityPlayer)) return;
		ItemStack[] tInv = aEvent.entityPlayer.inventory.mainInventory;
		if (aEvent.entityPlayer.inventory.mainInventory.length != 36) return;
		int tSlot = aEvent.entityPlayer.inventory.currentItem;
		ItemStack tCompare = aEvent.original;
		if (tCompare == null || OP.scrapGt.contains(tCompare)) tCompare = ST.make(ToolsGT.sMetaTool, 1, W);
		
		if (OP.scrapGt.contains(tInv[tSlot])) {
			ItemStack tScrap = ST.copy(tInv[tSlot]);
			tInv[tSlot] = ST.make(Blocks.cobblestone, 0, 0);
			UT.Inventories.addStackToPlayerInventoryOrDrop(aEvent.entityPlayer, tScrap, F);
			tInv[tSlot] = null;
		}
		
		if (tInv[tSlot] == null || tInv[tSlot].stackSize == 0) {
			if (tSlot < 9) {
				if (ST.equal(tCompare, tInv[tSlot+27], T)) {
				if (ST.equal(tCompare, tInv[tSlot+18], T)) {
				if (ST.equal(tCompare, tInv[tSlot+ 9], T)) {
				tInv[tSlot] = tInv[tSlot+ 9]; tInv[tSlot+ 9] = null; if (aEvent.entityPlayer.openContainer != null) aEvent.entityPlayer.openContainer.detectAndSendChanges(); return;}
				tInv[tSlot] = tInv[tSlot+18]; tInv[tSlot+18] = null; if (aEvent.entityPlayer.openContainer != null) aEvent.entityPlayer.openContainer.detectAndSendChanges(); return;}
				tInv[tSlot] = tInv[tSlot+27]; tInv[tSlot+27] = null; if (aEvent.entityPlayer.openContainer != null) aEvent.entityPlayer.openContainer.detectAndSendChanges(); return;}
				return;
			}
			if (tSlot < 18) {
				if (ST.equal(tCompare, tInv[tSlot+18], T)) {
				if (ST.equal(tCompare, tInv[tSlot+ 9], T)) {
				tInv[tSlot] = tInv[tSlot+ 9]; tInv[tSlot+ 9] = null; if (aEvent.entityPlayer.openContainer != null) aEvent.entityPlayer.openContainer.detectAndSendChanges(); return;}
				tInv[tSlot] = tInv[tSlot+18]; tInv[tSlot+18] = null; if (aEvent.entityPlayer.openContainer != null) aEvent.entityPlayer.openContainer.detectAndSendChanges(); return;}
				return;
			}
			if (tSlot < 27) {
				if (ST.equal(tCompare, tInv[tSlot+ 9], T)) {
				tInv[tSlot] = tInv[tSlot+ 9]; tInv[tSlot+ 9] = null; if (aEvent.entityPlayer.openContainer != null) aEvent.entityPlayer.openContainer.detectAndSendChanges(); return;}
				return;
			}
		}
	}
	
	@SubscribeEvent
	public void onItemUseFinish(PlayerUseItemEvent.Finish aEvent) {
		int[] tStats = FoodsGT.get(aEvent.item);
		if (tStats != null) {
			EntityFoodTracker tTracker = EntityFoodTracker.get(aEvent.entityPlayer);
			if (tTracker != null) {
				if (tStats.length > 0 && tStats[0] != 0) tTracker.changeAlcohol(tStats[0]);
				if (tStats.length > 1 && tStats[1] != 0) tTracker.changeCaffeine(tStats[1]);
				if (tStats.length > 2 && tStats[2] != 0) tTracker.changeDehydration(tStats[2]);
				if (tStats.length > 3 && tStats[3] != 0) tTracker.changeSugar(tStats[3]);
				if (tStats.length > 4 && tStats[4] != 0) tTracker.changeFat(tStats[4]);
			}
		}
		
		NBTTagCompound tNBT = aEvent.item.getTagCompound();
		if (tNBT != null && tNBT.hasKey(NBT_EFFECTS)) {
			tNBT = tNBT.getCompoundTag(NBT_EFFECTS);
			int tID = tNBT.getInteger("id"), tTime = tNBT.getInteger("time"), tLevel = tNBT.getInteger("lvl"), tChance = tNBT.getInteger("chance");
			if (tID < -1) switch(tID) {
			case -2: tID = PotionsGT.ID_RADIATION; break;
			case -3: tID = PotionsGT.ID_HYPOTHERMIA; break;
			case -4: tID = PotionsGT.ID_HEATSTROKE; break;
			case -5: tID = PotionsGT.ID_FROSTBITE; break;
			case -6: tID = PotionsGT.ID_DEHYDRATION; break;
			case -7: tID = PotionsGT.ID_INSANITY; break;
			}
			if (tID >= 0 && RANDOM.nextInt(100) < tChance) {
				if (tLevel >= 0) {
					aEvent.entityPlayer.addPotionEffect(new PotionEffect(tID, tTime, tLevel, F));
				} else {
					aEvent.entityPlayer.removePotionEffect(tID);
				}
			}
		}
		
		if (aEvent.item.getItem() == Items.apple) {
			if (IL.GrC_Applecore.exists()) {
				if (aEvent.result == null) aEvent.result = IL.GrC_Applecore.get(1); else UT.Inventories.addStackToPlayerInventoryOrDrop(aEvent.entityPlayer, IL.GrC_Applecore.get(1), F);
			} else if (IL.Food_Apple_Red_Core.exists()) {
				if (aEvent.result == null) aEvent.result = IL.Food_Apple_Red_Core.get(1); else UT.Inventories.addStackToPlayerInventoryOrDrop(aEvent.entityPlayer, IL.Food_Apple_Red_Core.get(1), F);
			}
		}
	}
	
	@SubscribeEvent
	public void onPlayerInteraction(PlayerInteractEvent aEvent) {
		if (aEvent.entityPlayer == null || aEvent.entityPlayer.worldObj == null || aEvent.action == null || aEvent.world.provider == null || aEvent.action == null) return;
		
		ItemStack aStack = aEvent.entityPlayer.inventory.getCurrentItem();
//		Block aBlock = aEvent.world.getBlock(aEvent.x, aEvent.y, aEvent.z);
		TileEntity aTileEntity = aEvent.world.getTileEntity(aEvent.x, aEvent.y, aEvent.z);
		
		if (aEvent.action == PlayerInteractEvent.Action.RIGHT_CLICK_BLOCK || aEvent.action == PlayerInteractEvent.Action.RIGHT_CLICK_AIR) {
			if (ST.valid(aStack)) {
				if (aTileEntity instanceof ITileEntityBookShelf && ((ITileEntityBookShelf)aTileEntity).isShelfFace((byte)aEvent.face)) {
					aEvent.useBlock = Result.ALLOW;
					if (BooksGT.BOOK_REGISTER.containsKey(new ItemStackContainer(aStack)) || BooksGT.BOOK_REGISTER.containsKey(new ItemStackContainer(ST.copyMeta(W, aStack)))) {
						aEvent.useItem = Result.DENY;
					}
					return;
				}
			}
		}
		
		if (aEvent.action == PlayerInteractEvent.Action.RIGHT_CLICK_BLOCK) {
			if (aTileEntity instanceof TileEntityJukebox) {
				ItemStack tStack = ((TileEntityJukebox)aTileEntity).func_145856_a();
				if (tStack != null) tStack.stackSize = 1;
				return;
			}
			if (ST.valid(aStack)) {
				if (aStack.getItem() instanceof IFluidContainerItem && !aEvent.entityPlayer.isSneaking() && aTileEntity != null && aTileEntity.getClass().getName().startsWith("mods.railcraft.common")) {
					aEvent.setCanceled(T);
					return;
				}
				/*
				if (MD.IC2.mLoaded && SIDES_HORIZONTAL[aEvent.face] && !aEvent.entityPlayer.isSneaking() && !aEvent.entityPlayer.capabilities.allowEdit && !aEvent.world.canPlaceEntityOnSide(aBlock, aEvent.x+OFFSETS_X[aEvent.face], aEvent.y, aEvent.z+OFFSETS_Z[aEvent.face], F, aEvent.face, aEvent.entityPlayer, aStack)) {
					if (IL.IC2_Scaffold.exists() && aBlock == IL.IC2_Scaffold.block() && IL.IC2_Scaffold.equal(aStack, F, T)) {
						aBlock.onBlockClicked(aEvent.world, aEvent.x, aEvent.y, aEvent.z, aEvent.entityPlayer);
						aEvent.entityPlayer.swingItem();
						aEvent.setCanceled(T);
						return;
					}
					if (IL.IC2_Scaffold_Iron.exists() && aBlock == IL.IC2_Scaffold_Iron.block() && IL.IC2_Scaffold_Iron.equal(aStack, F, T)) {
						aBlock.onBlockClicked(aEvent.world, aEvent.x, aEvent.y, aEvent.z, aEvent.entityPlayer);
						aEvent.entityPlayer.swingItem();
						aEvent.setCanceled(T);
						return;
					}
				}*/
				if (!(aStack.getItem() instanceof IItemNoGTOverride)) {
					// Dollies won't work on GT TileEntities, so to prevent a Crash I just disable the interaction.
					if (IL.JABBA_Dolly.equal(aStack, T, T) || IL.JABBA_Dolly_Diamond.equal(aStack, T, T)) {
						if (aTileEntity instanceof ITileEntitySpecificPlacementBehavior) {
							UT.Entities.chat(aEvent.entityPlayer, CHAT_GREG + " The Code of this Dolly is not smart enough to move this TileEntity.", CHAT_GREG + "It would crash if it actually did, so be glad I prevented that mistake.");
							aEvent.setCanceled(T);
						}
						return;
					}
					if (IL.RC_Crowbar_Iron.equal(aStack, T, T) || IL.RC_Crowbar_Steel.equal(aStack, T, T) || IL.RC_Crowbar_Thaumium.equal(aStack, T, T) || IL.RC_Crowbar_Voidmetal.equal(aStack, T, T)) {
						List<String> tChatReturn = new ArrayListNoNulls<String>();
						long tDamage = IBlockToolable.Util.onToolClick(TOOL_crowbar, Long.MAX_VALUE, 2, aEvent.entityPlayer, tChatReturn, aEvent.entityPlayer.inventory, aEvent.entityPlayer.isSneaking(), aStack, aEvent.entityPlayer.worldObj, (byte)aEvent.face, aEvent.x, aEvent.y, aEvent.z, 0.5F, 0.5F, 0.5F);
						UT.Entities.chat(aEvent.entityPlayer, tChatReturn, F);
						if (tDamage > 0) {
							aStack.damageItem((int)UT.Code.units(tDamage, 10000, 1, T), aEvent.entityPlayer);
							if (aStack.getItemDamage() >= aStack.getMaxDamage()) aStack.stackSize--;
							if (aStack.stackSize <= 0) ForgeEventFactory.onPlayerDestroyItem(aEvent.entityPlayer, aStack);
							aEvent.setCanceled(T);
						}
						return;
					}
					if (IL.FR_Scoop.equal(aStack, T, T)) {
						List<String> tChatReturn = new ArrayListNoNulls<String>();
						long tDamage = IBlockToolable.Util.onToolClick(TOOL_scoop, Long.MAX_VALUE, 0, aEvent.entityPlayer, tChatReturn, aEvent.entityPlayer.inventory, aEvent.entityPlayer.isSneaking(), aStack, aEvent.entityPlayer.worldObj, (byte)aEvent.face, aEvent.x, aEvent.y, aEvent.z, 0.5F, 0.5F, 0.5F);
						UT.Entities.chat(aEvent.entityPlayer, tChatReturn, F);
						if (tDamage > 0) {
							aStack.damageItem((int)UT.Code.units(tDamage, 10000, 1, T), aEvent.entityPlayer);
							if (aStack.getItemDamage() >= aStack.getMaxDamage()) aStack.stackSize--;
							if (aStack.stackSize <= 0) ForgeEventFactory.onPlayerDestroyItem(aEvent.entityPlayer, aStack);
							aEvent.setCanceled(T);
						}
						return;
					}
				}
			}
		}
	}
	
	@SubscribeEvent
	public void onBlockBreakSpeedEvent(PlayerEvent.BreakSpeed aEvent) {
		if (aEvent.newSpeed > 0) {
			if (aEvent.entityPlayer != null) {
				ItemStack aStack = aEvent.entityPlayer.getCurrentEquippedItem();
				if (aStack != null && aStack.getItem() instanceof MultiItemTool) aEvent.newSpeed = ((MultiItemTool)aStack.getItem()).onBlockBreakSpeedEvent(aEvent.newSpeed, aStack, aEvent.entityPlayer, aEvent.block, aEvent.x, aEvent.y, aEvent.z, (byte)aEvent.metadata, aEvent);
			}
			
			ItemStackContainer tBlock = new ItemStackContainer(aEvent.block, 1, aEvent.metadata);
			
				 if (OM.prefixcontains(ST.make(aEvent.block, 1, aEvent.metadata), TD.Prefix.ORE)) aEvent.newSpeed /= HARDNESS_MULTIPLIER_ORES;
			else if (BlocksGT.stoneToBrokenOres.containsKey(tBlock) || BlocksGT.stoneToNormalOres.containsKey(tBlock) || BlocksGT.stoneToSmallOres.containsKey(tBlock)) {if (aEvent.block.getMaterial() == Material.sand || aEvent.block.getMaterial() == Material.clay || aEvent.block.getMaterial() == Material.grass || aEvent.block.getMaterial() == Material.ground) aEvent.newSpeed /= HARDNESS_MULTIPLIER_SAND; else aEvent.newSpeed /= HARDNESS_MULTIPLIER_ROCK;}
			else if (aEvent.block instanceof IBlockPlacable) {if (BlocksGT.stoneToBrokenOres.containsValue(aEvent.block) || BlocksGT.stoneToNormalOres.containsValue(aEvent.block) || BlocksGT.stoneToSmallOres.containsValue(aEvent.block)) aEvent.newSpeed /= HARDNESS_MULTIPLIER_ORES;}
		}
	}
	
	@SubscribeEvent
	public void onBlockHarvestingEvent(BlockEvent.HarvestDropsEvent aEvent) {
		if (IL.TG_Ore_Cluster_1.exists() || IL.TG_Ore_Cluster_2.exists()) {
			Iterator<ItemStack> aDrops = aEvent.drops.iterator();
			while (aDrops.hasNext()) {
				ItemStack tDrop = aDrops.next();
				if (IL.TG_Ore_Cluster_1.equal(tDrop, T, T) || IL.TG_Ore_Cluster_2.equal(tDrop, T, T)) aDrops.remove();
			}
		}
		if (aEvent.harvester != null) {
			if (FAST_LEAF_DECAY) WD.leafdecay(aEvent.world, aEvent.x, aEvent.y, aEvent.z, aEvent.block);
			ItemStack aStack = aEvent.harvester.getCurrentEquippedItem();
			if (aStack != null) {
				boolean tFireAspect = (EnchantmentHelper.getEnchantmentLevel(Enchantment.fireAspect.effectId, aStack) >= 3), tCanCollect = (aStack.getItem() instanceof MultiItemTool && ((MultiItemTool)aStack.getItem()).canCollectDropsDirectly(aStack, aEvent.block, (byte)aEvent.blockMetadata));
				if (aStack.getItem() instanceof MultiItemTool) {
					((MultiItemTool)aStack.getItem()).onHarvestBlockEvent(aEvent.drops, aStack, aEvent.harvester, aEvent.block, aEvent.x, aEvent.y, aEvent.z, (byte)aEvent.blockMetadata, aEvent.fortuneLevel, aEvent.isSilkTouching, aEvent);
				}
				if (tFireAspect) for (ItemStack tDrop : aEvent.drops) {
					ItemStack tSmeltingOutput = RM.get_smelting(tDrop, F, null);
					if (tSmeltingOutput != null) {
						tDrop.stackSize *= tSmeltingOutput.stackSize;
						ST.set(tDrop, tSmeltingOutput, F, T);
					}
				}
				if (tCanCollect) {
					Iterator<ItemStack> aDrops = aEvent.drops.iterator();
					while (aDrops.hasNext()) if (UT.Inventories.addStackToPlayerInventory(aEvent.harvester, aDrops.next())) aDrops.remove();
				}
			}
			UT.Inventories.removeNullStacksFromInventory(aEvent.harvester.inventory);
		}
	}
	
	public static List<EntityPlayerMP> mNewPlayers = new ArrayListNoNulls<EntityPlayerMP>();
	
	@SubscribeEvent
	public void onLivingDeath(LivingDeathEvent aEvent) {
		if (aEvent.entityLiving instanceof EntityPlayerMP) NW_API.sendToPlayer(new PacketDeathPoint(MathHelper.floor_double(aEvent.entityLiving.posX), MathHelper.floor_double(aEvent.entityLiving.posY), MathHelper.floor_double(aEvent.entityLiving.posZ)), (EntityPlayerMP)aEvent.entityLiving);
	}
	
	@SubscribeEvent
	public void onLoginEvent(cpw.mods.fml.common.gameevent.PlayerEvent.PlayerLoggedInEvent aEvent) {
		if (aEvent.player.worldObj.isRemote) return;
		if (aEvent.player instanceof EntityPlayerMP) mNewPlayers.add((EntityPlayerMP)aEvent.player);
	}
	
	@Override
	public void generate(Random aRandom, int aChunkX, int aChunkZ, World aWorld, IChunkProvider aChunkGenerator, IChunkProvider aChunkProvider) {
		GT6WorldGenerator.generate(aWorld, aChunkX << 4, aChunkZ << 4, F);
	}
	/*
	@SubscribeEvent
	public void populate(PopulateChunkEvent.Post aEvent) {
		WorldGeneratorGT6.generate(aEvent.world, aEvent.chunkX << 4, aEvent.chunkZ << 4, F);
	}
	*/
	@SubscribeEvent
	@Optional.Method(modid = ModIDs.GC)
	public void populate(GCCoreEventPopulate.Post aEvent) {
		GT6WorldGenerator.generate(aEvent.worldObj, aEvent.chunkX, aEvent.chunkZ, T);
	}
	
	@SubscribeEvent
	public void onItemExpireEvent(ItemExpireEvent aEvent) {
		ItemStack aStack = aEvent.entityItem.getEntityItem();
		if (aStack != null && aStack.getItem() instanceof MultiTileEntityItemInternal) {
			long tExtraLife = ((MultiTileEntityItemInternal)aStack.getItem()).onDespawn(aEvent.entityItem, aStack);
			if (aStack.stackSize <= 0) {aEvent.entityItem.setDead(); return;}
			aEvent.entityItem.setEntityItemStack(aStack);
			if (tExtraLife > 0) {
				aEvent.extraLife = UT.Code.bindInt(aEvent.extraLife + tExtraLife);
				aEvent.setCanceled(T);
			}
		}
	}
	
	@SubscribeEvent
	public void onCheckSpawnEvent(LivingSpawnEvent.CheckSpawn aEvent) {
		if (aEvent.getResult() == Result.DENY || aEvent.world.provider.dimensionId != 0 || aEvent.y <= 50) return;
		if (GENERATE_STREETS && (UT.Code.inside(-48, 48, (int)aEvent.x) || UT.Code.inside(-48, 48, (int)aEvent.z))) {aEvent.setResult(Result.DENY); return;}
		if (SPAWN_ZONE_MOB_PROTECTION && UT.Code.inside(-144, 144, ((int)aEvent.x)-aEvent.world.getWorldInfo().getSpawnX()) && UT.Code.inside(-144, 144, ((int)aEvent.z)-aEvent.world.getWorldInfo().getSpawnZ())) {aEvent.setResult(Result.DENY); return;}
	}
	
	@SubscribeEvent
	public void onEntitySpawningEvent(EntityJoinWorldEvent aEvent) {
		if (aEvent.entity != null && !aEvent.entity.worldObj.isRemote) {
			if (aEvent.entity instanceof EntityItem) {
				ItemStack aStack = ST.update(OM.get(((EntityItem)aEvent.entity).getEntityItem()));
				if (ST.valid(aStack) && aStack.stackSize > 0) {
					if (((EntityItem)aEvent.entity).lifespan > 1200) {
						if (aStack.getItem() == Items.egg) {
							((EntityItem)aEvent.entity).lifespan = 1200;
						} else {
						//	if (MD.GT.mLoaded) {
						//		if (aStack.getItem() == Items.stick) {
						//			((EntityItem)aEvent.entity).lifespan = 200;
						//		} else {
						//			OreDictItemData tData = OM.data(aStack);
						//			if (tData != null && tData.mPrefix == OP.rockGt) {
						//				((EntityItem)aEvent.entity).lifespan = 200;
						//			} else if (((EntityItem)aEvent.entity).lifespan == 6000) {
						//				((EntityItem)aEvent.entity).lifespan = ITEM_DESPAWN_TIME;
						//			}
						//		}
						//	} else {
								if (((EntityItem)aEvent.entity).lifespan == 6000) {
									((EntityItem)aEvent.entity).lifespan = ITEM_DESPAWN_TIME;
								}
						//	}
						}
					}
					((EntityItem)aEvent.entity).setEntityItemStack(aStack);
				} else {
					aEvent.entity.setDead();
				}
			}
		}
	}
	
	@SubscribeEvent
	public void onEntityConstructingEvent(EntityConstructing aEvent) {
		if (Abstract_Mod.sFinalized >= Abstract_Mod.sModCountUsingGTAPI && aEvent.entity instanceof EntityPlayer) EntityFoodTracker.add((EntityPlayer)aEvent.entity);
	}
	
	@SubscribeEvent
	public void onArrowNockEvent(ArrowNockEvent aEvent) {
		if (!aEvent.isCanceled() && ST.valid(aEvent.result) && UT.Inventories.getProjectile(TD.Projectiles.ARROW, aEvent.entityPlayer.inventory) != null) {
			aEvent.entityPlayer.setItemInUse(aEvent.result, aEvent.result.getItem().getMaxItemUseDuration(aEvent.result));
			aEvent.setCanceled(T);
		}
	}
	
	@SubscribeEvent
	public void onArrowLooseEvent(ArrowLooseEvent aEvent) {
		ItemStack aArrow = UT.Inventories.getProjectile(TD.Projectiles.ARROW, aEvent.entityPlayer.inventory);
		if (!aEvent.isCanceled() && ST.valid(aEvent.bow) && aArrow != null && aEvent.bow.getItem() instanceof ItemBow) {
			float tSpeed = aEvent.charge / 20.0F;
			tSpeed = (tSpeed * tSpeed + tSpeed * 2.0F) / 3.0F;
			
			if (tSpeed < 0.1) return;
			if (tSpeed > 1.0) tSpeed = 1.0F;
			
			EntityProjectile tArrowEntity = ((IItemProjectile)aArrow.getItem()).getProjectile(TD.Projectiles.ARROW, aArrow, aEvent.entityPlayer.worldObj, aEvent.entityPlayer, tSpeed * 2.0F);
			
			if (tSpeed >= 1.0F) tArrowEntity.setIsCritical(T);
			
			int
			tLevel = EnchantmentHelper.getEnchantmentLevel(Enchantment.power.effectId, aEvent.bow);
			if (tLevel > 0) tArrowEntity.setDamage(tArrowEntity.getDamage() + tLevel * 0.5D + 0.5D);
			tLevel = EnchantmentHelper.getEnchantmentLevel(Enchantment.punch.effectId, aEvent.bow);
			if (tLevel > 0) tArrowEntity.setKnockbackStrength(tLevel);
			tLevel = EnchantmentHelper.getEnchantmentLevel(Enchantment.flame.effectId, aEvent.bow);
			if (tLevel > 0) tArrowEntity.setFire(tLevel * 100);
			
			aEvent.bow.damageItem(1, aEvent.entityPlayer);
			aEvent.bow.getItem();
			aEvent.entityPlayer.worldObj.playSoundAtEntity(aEvent.entityPlayer, "random.bow", 1.0F, 1.0F / (RANDOM.nextFloat() * 0.4F + 1.2F) + tSpeed * 0.5F);
			
			tArrowEntity.canBePickedUp = 1;
			
			if (!UT.Entities.hasInfiniteItems(aEvent.entityPlayer)) aArrow.stackSize--;
			if (aArrow.stackSize == 0) UT.Inventories.removeNullStacksFromInventory(aEvent.entityPlayer.inventory);
			
			if (!aEvent.entityPlayer.worldObj.isRemote) aEvent.entityPlayer.worldObj.spawnEntityInWorld(tArrowEntity);
			
			aEvent.setCanceled(T);
		}
	}
	
	@Override
	public int getBurnTime(ItemStack aFuel) {
		if (ST.invalid(aFuel) || UT.Fluids.getFluidForFilledItem(aFuel, T) != null) return 0;
		Block aBlock = ST.block(aFuel);
		if (aBlock == BlocksGT.BalesGrass) return (9 * TICKS_PER_SMELT) / ((ST.meta(aFuel) & 3) == 1 ? 2 : 4);
		if (aBlock instanceof BlockBaseBale) return (9 * TICKS_PER_SMELT) / 4;
		if (aBlock instanceof BlockBasePlanks) return (3 * TICKS_PER_SMELT) / 2;
		if (aBlock instanceof BlockBaseSapling) return TICKS_PER_SMELT / 2;
		if (aBlock instanceof BlockBaseBeam || aBlock instanceof BlockBaseLog) return TICKS_PER_SMELT * 6;
		long rFuelValue = 0;
		if (aFuel.getItem() instanceof MultiItemRandom) {
			Short tFuelValue = ((MultiItemRandom)aFuel.getItem()).mBurnValues.get(ST.meta(aFuel));
			if (tFuelValue != null) rFuelValue = (short)Math.max(rFuelValue, tFuelValue);
		} else {
			if (OM.is_("logWood", aFuel)) return TICKS_PER_SMELT * 6;
		}
		NBTTagCompound tNBT = aFuel.getTagCompound();
		if (tNBT != null) {
			rFuelValue = Math.max(rFuelValue, tNBT.getLong(NBT_FUEL_VALUE));
		}
		OreDictItemData tData = OM.anydata_(aFuel);
		if (tData != null && (tData.mPrefix == null || tData.mPrefix.contains(TD.Prefix.BURNABLE))) {
			long tBurnTime = 0;
			for (OreDictMaterialStack tMaterial : tData.getAllMaterialStacks()) tBurnTime += UT.Code.units(tMaterial.mMaterial.mFurnaceBurnTime, U, tMaterial.mAmount, F);
			rFuelValue = Math.max(rFuelValue, tBurnTime);
		}
		return UT.Code.bind15(rFuelValue);
	}
}